<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Symbols</TITLE>
<link href="suif1_52.html" rel=Next>
<link href="suif1_50.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_50.html">previous</A>, <A HREF="suif1_52.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC51" HREF="suif1_toc.html#TOC51">Symbols</A></H1>
<P>
<A NAME="IDX331"></A>

</P>
<P>
<A NAME="IDX332"></A>
<A NAME="IDX333"></A>
<A NAME="IDX334"></A>
<A NAME="IDX335"></A>
SUIF symbols are stored in the symbol tables (see section <A HREF="suif1_40.html#SEC40">Symbol Tables</A>) to
represent variables, labels, and procedures.  The <CODE>sym_node</CODE> class
is the base class for all SUIF symbols.  This is an abstract class so it
cannot be used directly.  The library also defines the
<CODE>sym_node_list</CODE> class for lists of pointers to symbols.  Classes
are derived from the <CODE>sym_node</CODE> class for each kind of symbol.
Given an arbitrary symbol, the <CODE>kind</CODE> method identifies the kind of
symbol and thus the derived class to which it belongs.  This method
returns a value from the <CODE>sym_kinds</CODE> enumerated type.  The
following values are defined in that enumeration:

</P>
<DL COMPACT>

<DT><CODE>SYM_VAR</CODE>
<DD>
Variable symbol.  The <CODE>var_sym</CODE> class represents variable symbols.

<DT><CODE>SYM_LABEL</CODE>
<DD>
Label symbol.  The <CODE>label_sym</CODE> class represents label symbols.

<DT><CODE>SYM_PROC</CODE>
<DD>
Procedure symbol.  The <CODE>proc_sym</CODE> class represents procedure symbols.
</DL>

<P>
All symbols share some common fields including the symbol names.  These
are described in the first section below.  Each kind of symbol also uses
additional fields that are specific to that kind.  For example, variable
symbols specify the types of the variables.  The subsequent sections
describe the specific features of each kind of symbol.

</P>
<P>
The <TT>`symbols.h'</TT> and <TT>`symbols.cc'</TT> files contain the source
code for SUIF symbols.

</P>

<UL>
<LI><A HREF="suif1_52.html#SEC52">Symbol Features</A>: Basic features of all symbols.
<LI><A HREF="suif1_53.html#SEC53">Procedure Symbols</A>: Procedures.
<LI><A HREF="suif1_54.html#SEC54">Label Symbols</A>: Labels.
<LI><A HREF="suif1_55.html#SEC55">Variable Symbols</A>: Variables.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_50.html">previous</A>, <A HREF="suif1_52.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
